#!/usr/bin/env node
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./dist/scripts/unibit.js");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./dist/converters/consts.js":
/*!***********************************!*\
  !*** ./dist/converters/consts.js ***!
  \***********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GATSBY = exports.HUGO = exports.JEKYLL = exports.BODY_TEMPLATE_FILE_NAME = exports.BASE_TEMPLATE_FILE_NAME = exports.POST_BODY_COMPONENT_FILE_NAME = exports.HTML_HEAD_COMPONENT_FILE_NAME = exports.SSG_TYPES = exports.default = void 0;
var SSG_TYPES = {
  JEKYLL: 'jekyll',
  HUGO: 'hugo',
  HEXO: 'hexo',
  GATSBY: 'gatsby',
  VUEPRESS: 'vuepress'
};
exports.SSG_TYPES = SSG_TYPES;
var HTML_HEAD_COMPONENT_FILE_NAME = 'html_head.html';
exports.HTML_HEAD_COMPONENT_FILE_NAME = HTML_HEAD_COMPONENT_FILE_NAME;
var POST_BODY_COMPONENT_FILE_NAME = 'post_body.html';
exports.POST_BODY_COMPONENT_FILE_NAME = POST_BODY_COMPONENT_FILE_NAME;
var BASE_TEMPLATE_FILE_NAME = 'base.html';
exports.BASE_TEMPLATE_FILE_NAME = BASE_TEMPLATE_FILE_NAME;
var BODY_TEMPLATE_FILE_NAME = 'body.html';
exports.BODY_TEMPLATE_FILE_NAME = BODY_TEMPLATE_FILE_NAME;
var JEKYLL = {
  ssgName: SSG_TYPES.JEKYLL,
  configFilePath: '_config.yml',
  dataDir: '_data',
  pagesDir: '',
  staticDir: '',
  pageTemplateKey: 'layout',
  templatesDir: '_layouts',
  componentsDir: '_includes'
};
exports.JEKYLL = JEKYLL;
var HUGO = {
  ssgName: SSG_TYPES.HUGO,
  configFilePath: 'config.yaml',
  dataDir: 'data',
  pagesDir: 'content',
  staticDir: 'static',
  pageTemplateKey: 'layout',
  templatesDir: 'layouts/_default',
  componentsDir: 'layouts/partials'
};
exports.HUGO = HUGO;
var GATSBY = {
  ssgName: SSG_TYPES.GATSBY,
  configFilePath: 'site-metadata.json',
  dataDir: 'src/data',
  pagesDir: 'src/pages',
  staticDir: 'static',
  pageTemplateKey: 'template',
  templatesDir: 'src/templates',
  componentsDir: 'src/components'
};
exports.GATSBY = GATSBY;
var UNIBIT = {
  ssgName: 'unibit',
  configFilePath: 'config.yml',
  dataDir: 'data',
  pagesDir: 'content',
  staticDir: 'static',
  pageTemplateKey: 'template',
  templatesDir: 'templates',
  componentsDir: 'components'
};
var _default = {
  SSG_TYPES: SSG_TYPES,
  HTML_HEAD_COMPONENT_FILE_NAME: HTML_HEAD_COMPONENT_FILE_NAME,
  POST_BODY_COMPONENT_FILE_NAME: POST_BODY_COMPONENT_FILE_NAME,
  BASE_TEMPLATE_FILE_NAME: BASE_TEMPLATE_FILE_NAME,
  BODY_TEMPLATE_FILE_NAME: BODY_TEMPLATE_FILE_NAME,
  JEKYLL: JEKYLL,
  HUGO: HUGO,
  GATSBY: GATSBY,
  UNIBIT: UNIBIT
};
exports.default = _default;
//# sourceMappingURL=consts.js.map

/***/ }),

/***/ "./dist/loaders/base-loader.js":
/*!*************************************!*\
  !*** ./dist/loaders/base-loader.js ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(__webpack_require__(/*! lodash */ "lodash"));

var _fs = _interopRequireDefault(__webpack_require__(/*! fs */ "fs"));

var _path = _interopRequireDefault(__webpack_require__(/*! path */ "path"));

var _jsYaml = _interopRequireDefault(__webpack_require__(/*! js-yaml */ "js-yaml"));

var _moment = _interopRequireDefault(__webpack_require__(/*! moment */ "moment"));

var _utils = _interopRequireDefault(__webpack_require__(/*! ../utils */ "./dist/utils.js"));

var _site = _interopRequireDefault(__webpack_require__(/*! ../models/site */ "./dist/models/site.js"));

var _consts = _interopRequireDefault(__webpack_require__(/*! ./consts */ "./dist/loaders/consts.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var BaseLoader =
/*#__PURE__*/
function () {
  function BaseLoader(options) {
    _classCallCheck(this, BaseLoader);

    this.inputDir = _lodash.default.get(options, 'inputDir');
    this.ssgName = _lodash.default.get(options, 'ssgName');

    if (!this.inputDir) {
      this.fail("options.inputDir must be specified");
    }

    if (!_fs.default.existsSync(_path.default.resolve(this.inputDir))) {
      this.fail("input directory '".concat(this.inputDir, "' does not exist"));
    }

    this.configFilePath = _lodash.default.get(options, 'configFilePath');
    this.dataDir = _lodash.default.get(options, 'dataDir');
    this.pagesDir = _lodash.default.get(options, 'pagesDir');
    this.staticDir = _lodash.default.get(options, 'staticDir');
    this.pageTemplateKey = _lodash.default.get(options, 'pageTemplateKey');
    this.templatesDir = _path.default.resolve(this.inputDir, _lodash.default.get(options, 'templatesDir'));
    this.componentsDir = _path.default.resolve(this.inputDir, _lodash.default.get(options, 'componentsDir'));
  }

  _createClass(BaseLoader, [{
    key: "fail",
    value: function fail(message) {
      throw new Error("[".concat(this.constructor.name, "] ").concat(message));
    }
  }, {
    key: "assert",
    value: function assert(value, message) {
      if (!value) {
        this.fail(message);
      }
    }
    /**
     * @return {Site}
     */

  }, {
    key: "loadSite",
    value: function loadSite() {
      console.log("[".concat(this.constructor.name, "] loading site from ").concat(_path.default.resolve(this.inputDir)));
      var data = {
        absPath: this.inputDir,
        ssgName: this.ssgName,
        staticDir: this.staticDir,
        dataDir: this.dataDir,
        pagesDir: this.pagesDir,
        pageTemplateKey: this.pageTemplateKey,
        config: this.loadConfig(),
        stackbitYml: this.loadStackbitYml(),
        dataFiles: this.loadData(),
        templates: this.loadTemplates(),
        components: this.loadComponents(),
        pageTree: this.loadPages()
      };
      data.pages = this.flattenPageTree(data.pageTree);

      var _this$createMenus = this.createMenus(data),
          menus = _this$createMenus.menus,
          menuNames = _this$createMenus.menuNames;

      data.menus = menus;
      data.menuNames = menuNames;
      return new _site.default(data);
    }
  }, {
    key: "loadConfig",
    value: function loadConfig() {
      var absPath = _path.default.resolve(this.inputDir, this.configFilePath);

      console.log("[".concat(this.constructor.name, "] loading config from: ").concat(absPath));

      if (!_fs.default.existsSync(absPath)) {
        this.fail("".concat(absPath, " does not exist"));
      }

      return {
        absPath: absPath,
        relPath: this.configFilePath,
        data: _utils.default.parseFileSync(absPath)
      };
    }
  }, {
    key: "loadStackbitYml",
    value: function loadStackbitYml() {
      var _this = this;

      var stackbitYmlPath = _lodash.default.chain([_consts.default.STACKBIT_YAML, _consts.default.CONTENT_MODEL_FILE]).map(function (filePath) {
        return _path.default.resolve(_this.inputDir, filePath);
      }).find(function (filePath) {
        return _fs.default.existsSync(filePath);
      }).value();

      if (!stackbitYmlPath) {
        return null;
      }

      console.log("[".concat(this.constructor.name, "] loading content model from: ").concat(stackbitYmlPath));
      return _utils.default.parseFileSync(stackbitYmlPath);
    }
  }, {
    key: "loadData",
    value: function loadData() {
      var absDataDir = _path.default.resolve(this.inputDir, this.dataDir);

      if (!_fs.default.existsSync(absDataDir)) {
        return null;
      }

      console.log("[".concat(this.constructor.name, "] loading data from: ").concat(absDataDir));
      var dataFiles = [];

      var files = _utils.default.readDirRecSync(absDataDir);

      _lodash.default.forEach(files, function (filePath) {
        var relFilePath = _path.default.relative(absDataDir, filePath);

        var pathObject = _path.default.parse(relFilePath);

        var data = _utils.default.parseFileSync(filePath);

        dataFiles.push({
          absPath: filePath,
          relPath: relFilePath,
          basename: pathObject.base,
          filename: pathObject.name,
          data: data
        });
      });

      return dataFiles;
    }
  }, {
    key: "loadTemplates",
    value: function loadTemplates() {
      console.log("[".concat(this.constructor.name, "] loading templates from: ").concat(this.templatesDir));
      return this.loadFiles(this.templatesDir);
    }
  }, {
    key: "loadComponents",
    value: function loadComponents() {
      console.log("[".concat(this.constructor.name, "] loading templates from: ").concat(this.componentsDir));
      return this.loadFiles(this.componentsDir);
    }
  }, {
    key: "loadFiles",
    value: function loadFiles(dirPath) {
      var _this2 = this;

      var files = [];

      _fs.default.readdirSync(dirPath).forEach(function (fileName) {
        var filePath = _path.default.resolve(dirPath, fileName);

        var fileStat = _fs.default.statSync(filePath);

        if (fileStat.isFile()) {
          var component = _this2.loadFile(filePath, dirPath);

          files.push(component);
        } else {
          _this2.fail("directory '".concat(dirPath, "' must include files only"));
        }
      });

      return files;
    }
  }, {
    key: "loadFile",
    value: function loadFile(filePath, baseDir) {
      var data = _fs.default.readFileSync(filePath, 'utf8');

      var pathObject = _path.default.parse(filePath);

      return {
        absPath: filePath,
        relPath: _path.default.relative(baseDir, filePath),
        basename: pathObject.base,
        filename: pathObject.name,
        data: data.trim()
      };
    }
  }, {
    key: "loadPages",
    value: function loadPages() {
      var absPagesDir = _path.default.resolve(this.inputDir, this.pagesDir);

      console.log("[".concat(this.constructor.name, "] loading pages from: ").concat(absPagesDir));
      return this.processPageDir(absPagesDir);
    }
  }, {
    key: "processPageDir",
    value: function processPageDir(pageDir) {
      var _this3 = this;

      var absPagesDir = _path.default.resolve(this.inputDir, this.pagesDir);

      var pageTree = {
        path: _path.default.relative(absPagesDir, pageDir),
        pages: [],
        folders: []
      };

      _fs.default.readdirSync(pageDir).forEach(function (fileName) {
        var filePath = _path.default.resolve(pageDir, fileName);

        var fileStat = _fs.default.statSync(filePath);

        if (fileStat.isDirectory()) {
          var folder = _this3.processPageDir(filePath);

          pageTree.folders.push(folder); // TODO: what if folder name is a number, add folderMap instead

          pageTree.folders[fileName] = folder;
        } else if (fileStat.isFile()) {
          var page = _this3.parsePageForFilePath(filePath);

          if (page) {
            pageTree.pages.push(page); // TODO: what if name is a number, add pageMap instead

            pageTree.pages[page.filename] = page;
          }
        } else {
          _this3.fail("page file type is not supported: ".concat(filePath));
        }
      });

      return pageTree;
    }
  }, {
    key: "parsePageForFilePath",
    value: function parsePageForFilePath(filePath) {
      var data = _fs.default.readFileSync(filePath, 'utf8');

      if (!data.startsWith('---\n')) {
        this.fail("page file ".concat(filePath, " does not have a valid frontmatter"));
      }

      var index = data.indexOf('\n---\n');

      if (index === -1) {
        this.fail("page file ".concat(filePath, " does not have a valid frontmatter"));
      }

      var absPagesDir = _path.default.resolve(this.inputDir, this.pagesDir);

      var pathObject = _path.default.parse(filePath);

      var relDir = _path.default.relative(absPagesDir, pathObject.dir);

      var yamlData = data.substring(4, index);

      var frontmatter = _jsYaml.default.safeLoad(yamlData, {
        schema: _jsYaml.default.JSON_SCHEMA
      });

      var markdown = data.substring(index + 5);
      var date;

      if (frontmatter.date) {
        date = new Date((0, _moment.default)(frontmatter.date).toISOString());
      } else {
        date = new Date(_fs.default.statSync(filePath).birthtimeMs);
      } // TODO: change spec to use frontmatter and remove frontmatter assign


      return Object.assign({}, frontmatter, {
        absPath: filePath,
        relPath: _path.default.relative(absPagesDir, filePath),
        absDir: pathObject.dir,
        relDir: relDir,
        url: _path.default.join(relDir, pathObject.name + '.html'),
        basename: pathObject.base,
        filename: pathObject.name,
        date: date,
        params: frontmatter,
        frontmatter: frontmatter,
        markdown: markdown
      });
    }
  }, {
    key: "flattenPageTree",
    value: function flattenPageTree(pageTree) {
      var _this4 = this;

      var pages = [];
      pageTree.folders.forEach(function (folder) {
        pages = pages.concat(_this4.flattenPageTree(folder));
      });
      return pages.concat(pageTree.pages);
    }
  }, {
    key: "createMenus",
    value: function createMenus(data) {
      var siteMenuItems = this.getSiteMenus(data);
      var pageMenuItems = this.getPageMenus(data);

      var menuItems = _lodash.default.chain(siteMenuItems).concat(pageMenuItems).compact().value();

      return this.createMenusFromMenuItems(menuItems);
    }
  }, {
    key: "getSiteMenus",
    value: function getSiteMenus(data) {
      return null;
    }
  }, {
    key: "getPageMenus",
    value: function getPageMenus(data) {
      var _this5 = this;

      var pageMenuItems = [];

      _lodash.default.forEach(data.pages, function (page) {
        pageMenuItems = pageMenuItems.concat(_this5.getPageMenuItems(page));
      });

      return pageMenuItems;
    }
  }, {
    key: "getPageMenuItems",
    value: function getPageMenuItems(page) {
      var menus = _lodash.default.get(page, 'menus', null);

      if (!menus || !_lodash.default.isPlainObject(menus)) {
        return [];
      }

      return _lodash.default.map(menus, function (menu, menuName) {
        var menuItem = {
          menu: menuName,
          title: _lodash.default.get(menu, 'title', page.title),
          url: page.url,
          weight: _lodash.default.toNumber(_lodash.default.get(menu, 'weight', page.date.getTime())),
          identifier: _lodash.default.get(menu, 'identifier', page.url),
          page: page
        }; // page.menuItems needed to overcome a bug in Jekyll-menus related to pagination

        _utils.default.append(page, 'menuItems', menuItem);

        return menuItem;
      });
    }
  }, {
    key: "createMenusFromMenuItems",
    value: function createMenusFromMenuItems(menuItems) {
      var _this6 = this;

      var rootMenus = {};
      var menusByName = {};
      var menuNames = [];

      _lodash.default.forEach(menuItems, function (menuItem) {
        var menuName = menuItem.menu;

        var identifier = _lodash.default.get(menuItem, 'identifier');

        var menu;

        if (!_lodash.default.includes(menuNames, menuName)) {
          menuNames.push(menuName);
        }

        if (!_lodash.default.has(menusByName, menuName)) {
          menu = [];
          rootMenus[menuName] = menu;
          menusByName[menuName] = menu;
        } else {
          menu = menusByName[menuName];
        }

        menuItem.children = []; // In case a menu item with a parent menu was defined before the item
        // with the menu identifier, copy that menu to menu item's children.

        if (_lodash.default.has(menusByName, identifier)) {
          if (_lodash.default.has(rootMenus, identifier)) {
            menuItem.children = rootMenus[identifier];
            delete rootMenus[identifier];
          } else {
            _this6.fail("A menu item identifier must be unique");
          }
        }

        menusByName[identifier] = menuItem.children;

        if (_lodash.default.has(menuItem, 'weight')) {
          var index = _lodash.default.sortedLastIndexBy(menu, menuItem, 'weight');

          menu.splice(index, 0, menuItem);
        } else {
          menu.push(menuItem);
        }
      });

      return {
        menus: rootMenus,
        menuNames: menuNames
      };
    }
  }]);

  return BaseLoader;
}();

exports.default = BaseLoader;
//# sourceMappingURL=base-loader.js.map

/***/ }),

/***/ "./dist/loaders/consts.js":
/*!********************************!*\
  !*** ./dist/loaders/consts.js ***!
  \********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _default = {
  STACKBIT_YAML: 'stackbit.yml',
  CONTENT_MODEL_FILE: 'content-model.yml'
};
exports.default = _default;
//# sourceMappingURL=consts.js.map

/***/ }),

/***/ "./dist/loaders/unibit-loader.js":
/*!***************************************!*\
  !*** ./dist/loaders/unibit-loader.js ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(__webpack_require__(/*! path */ "path"));

var _lodash = _interopRequireDefault(__webpack_require__(/*! lodash */ "lodash"));

var _consts = _interopRequireDefault(__webpack_require__(/*! ../converters/consts */ "./dist/converters/consts.js"));

var _baseLoader = _interopRequireDefault(__webpack_require__(/*! ./base-loader */ "./dist/loaders/base-loader.js"));

var _base = _interopRequireDefault(__webpack_require__(/*! ../supporting-files/unibit/base.html */ "./dist/supporting-files/unibit/base.html.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var UnibitLoader =
/*#__PURE__*/
function (_BaseLoader) {
  _inherits(UnibitLoader, _BaseLoader);

  function UnibitLoader(options) {
    _classCallCheck(this, UnibitLoader);

    return _possibleConstructorReturn(this, _getPrototypeOf(UnibitLoader).call(this, _lodash.default.assign({}, _consts.default.UNIBIT, options)));
  }

  _createClass(UnibitLoader, [{
    key: "loadTemplates",
    value: function loadTemplates() {
      var templates = _get(_getPrototypeOf(UnibitLoader.prototype), "loadTemplates", this).call(this);

      var baseLayoutFilePath = _path.default.resolve(this.templatesDir, _consts.default.BASE_TEMPLATE_FILE_NAME);

      var pathObject = _path.default.parse(baseLayoutFilePath);

      templates.push({
        absPath: baseLayoutFilePath,
        relPath: _path.default.relative(this.templatesDir, baseLayoutFilePath),
        basename: pathObject.base,
        filename: pathObject.name,
        data: _base.default
      });
      return templates;
    }
  }, {
    key: "getSiteMenus",
    value: function getSiteMenus(data) {
      var _this = this;

      var menus = _lodash.default.get(data.config.data, 'menus', null);

      if (!menus || !_lodash.default.isPlainObject(menus)) {
        return null;
      }

      return _lodash.default.flatMap(menus, function (menu, menuName) {
        return _lodash.default.map(menu, function (item, index) {
          var url = _lodash.default.get(item, 'url');

          var title = _lodash.default.get(item, 'title');

          var identifier = _lodash.default.get(item, 'identifier', "".concat(menuName, "_").concat(index + 1));

          var weight = _lodash.default.get(item, 'weight', null);

          _this.assert(url, "menu item defined in config file must have \"url\" field");

          _this.assert(title, "menu item defined in config file must have \"title\" field");

          _this.assert(identifier, "menu item defined in config file must have \"identifier\" field");

          var menuItem = {
            menu: menuName,
            title: title,
            url: url,
            identifier: identifier
          };

          if (weight !== null) {
            menuItem.weight = _lodash.default.toNumber(weight);
          }

          return menuItem;
        });
      });
    }
  }]);

  return UnibitLoader;
}(_baseLoader.default);

exports.default = UnibitLoader;
//# sourceMappingURL=unibit-loader.js.map

/***/ }),

/***/ "./dist/models/site.js":
/*!*****************************!*\
  !*** ./dist/models/site.js ***!
  \*****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(__webpack_require__(/*! lodash */ "lodash"));

var _path = _interopRequireDefault(__webpack_require__(/*! path */ "path"));

var _utils = _interopRequireDefault(__webpack_require__(/*! ../utils */ "./dist/utils.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Site =
/*#__PURE__*/
function () {
  function Site(data) {
    _classCallCheck(this, Site);

    this.absPath = data.absPath;
    this.ssgName = data.ssgName;
    this.staticDir = data.staticDir;
    this.dataDir = data.dataDir;
    this.pagesDir = data.pagesDir;
    this.pageTemplateKey = data.pageTemplateKey;
    this.config = data.config;
    this.stackbitYml = data.stackbitYml;
    this.dataFiles = data.dataFiles;
    this.templates = data.templates;
    this.components = data.components;
    this.pageTree = data.pageTree;
    this.menus = data.menus;
    this.menuNames = data.menuNames;

    if (data.pages) {
      this.pages = data.pages;
    } else {
      this.pages = this.flattenPageTree(this.pageTree);
    }

    this.data = this.mergeData(data.dataFiles);

    _utils.default.deepFreeze(this);
  }

  _createClass(Site, [{
    key: "clone",
    value: function clone(options) {
      var keys = _lodash.default.keys(this);

      var clonedData = _lodash.default.cloneDeep(_lodash.default.pick(this, keys));

      var data = _lodash.default.assign(clonedData, _lodash.default.pick(options, keys));

      return new Site(data);
    }
  }, {
    key: "mergeData",
    value: function mergeData(dataFiles) {
      var data = {};

      _lodash.default.forEach(dataFiles, function (dataFile) {
        var pathObject = _path.default.parse(dataFile.relPath);

        var props = _lodash.default.chain(pathObject.dir).split(_path.default.sep).concat(pathObject.name).compact().value();

        _lodash.default.set(data, props, dataFile.data);
      });

      return data;
    }
  }, {
    key: "clonePageTree",
    value: function clonePageTree(pageTree) {
      var _this = this;

      var pages = [];
      pageTree.pages.forEach(function (page) {
        var filename = page.filename;

        var clone = _lodash.default.cloneDeep(page);

        pages.push(clone);
        pages[filename] = clone;
      });
      var folders = [];
      pageTree.folders.forEach(function (folder) {
        var folderName = _path.default.relative(pageTree.path, folder.path);

        var clone = _this.clonePageTree(folder);

        folders.push(clone);
        folders[folderName] = clone;
      });
      return {
        path: pageTree.path,
        pages: pages,
        folders: folders
      };
    }
  }, {
    key: "flattenPageTree",
    value: function flattenPageTree(pageTree) {
      var _this2 = this;

      var pages = [];
      pageTree.folders.forEach(function (folder) {
        pages = pages.concat(_this2.flattenPageTree(folder));
      });
      return pages.concat(pageTree.pages);
    }
  }]);

  return Site;
}();

exports.default = Site;
//# sourceMappingURL=site.js.map

/***/ }),

/***/ "./dist/scripts/unibit.js":
/*!********************************!*\
  !*** ./dist/scripts/unibit.js ***!
  \********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _yargs = _interopRequireDefault(__webpack_require__(/*! yargs */ "yargs"));

var _path = _interopRequireDefault(__webpack_require__(/*! path */ "path"));

var _unibit = _interopRequireDefault(__webpack_require__(/*! ../unibit/unibit */ "./dist/unibit/unibit.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var argv = _yargs.default.usage('Usage: $0 <command> [options]').command('build', 'Build site', function (yargs) {
  return yargs.options({
    'input-dir': {
      alias: 'i',
      describe: 'Unibit site source directory.',
      default: function cws() {
        return process.cwd();
      },
      defaultDescription: 'current working directory'
    },
    'output-dir': {
      alias: 'o',
      describe: 'Target directory for the generated site.',
      default: function cwsPublic() {
        return _path.default.join(process.cwd(), 'public');
      },
      defaultDescription: '"build" folder inside current working directory'
    }
  });
}).demandCommand(1, 'You need to specify at least one command').example('$0 build -i path/to/source -o path/to/target', 'Build site from Unibit site located in the "path/to/source" folder and save it in the "path/to/target" folder.').wrap(null).help().argv;

if (argv._[0] === 'build') {
  var unibit = new _unibit.default({
    inputDir: argv.inputDir,
    outputDir: argv.outputDir
  });
  unibit.generate();
}
//# sourceMappingURL=unibit.js.map

/***/ }),

/***/ "./dist/supporting-files/unibit/base.html.js":
/*!***************************************************!*\
  !*** ./dist/supporting-files/unibit/base.html.js ***!
  \***************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = `<!doctype html>
<html>
    <head>
        {% include "html_head.html" %}
    </head>
    <body {% if templates.body_class %}class="{{ templates.body_class }}"{% endif %}>
        {% block body %}{% endblock %}
        {% include "post_body.html" %}
    </body>
</html>
`;


/***/ }),

/***/ "./dist/unibit/unibit-nunjucks-loader.js":
/*!***********************************************!*\
  !*** ./dist/unibit/unibit-nunjucks-loader.js ***!
  \***********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var baseHtml = __webpack_require__(/*! ../supporting-files/unibit/base.html */ "./dist/supporting-files/unibit/base.html.js");

function UnibitNunjucksLoader(opts) {}

UnibitNunjucksLoader.prototype.getSource = function (name) {
  // load the template
  // return an object with:
  //   - src:     String. The template source.
  //   - path:    String. Path to template.
  //   - noCache: Bool. Don't cache the template (optional).
  if (name === 'base.html') {
    return {
      src: baseHtml,
      path: name,
      noCache: false
    };
  }

  return null;
};

var _default = UnibitNunjucksLoader;
exports.default = _default;
//# sourceMappingURL=unibit-nunjucks-loader.js.map

/***/ }),

/***/ "./dist/unibit/unibit.js":
/*!*******************************!*\
  !*** ./dist/unibit/unibit.js ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(__webpack_require__(/*! path */ "path"));

var _fs = _interopRequireDefault(__webpack_require__(/*! fs */ "fs"));

var _fsExtra = _interopRequireDefault(__webpack_require__(/*! fs-extra */ "fs-extra"));

var _nunjucks = _interopRequireDefault(__webpack_require__(/*! nunjucks */ "nunjucks"));

var _marked = _interopRequireDefault(__webpack_require__(/*! marked */ "marked"));

var _prettier = _interopRequireDefault(__webpack_require__(/*! prettier */ "prettier"));

var _nodeSass = _interopRequireDefault(__webpack_require__(/*! node-sass */ "node-sass"));

var _strftime = _interopRequireDefault(__webpack_require__(/*! strftime */ "strftime"));

var _moment = _interopRequireDefault(__webpack_require__(/*! moment */ "moment"));

var _lodash = _interopRequireDefault(__webpack_require__(/*! lodash */ "lodash"));

var _unibitLoader = _interopRequireDefault(__webpack_require__(/*! ../loaders/unibit-loader */ "./dist/loaders/unibit-loader.js"));

var _unibitNunjucksLoader = _interopRequireDefault(__webpack_require__(/*! ./unibit-nunjucks-loader */ "./dist/unibit/unibit-nunjucks-loader.js"));

var _utils = _interopRequireDefault(__webpack_require__(/*! ../utils */ "./dist/utils.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Unibit =
/*#__PURE__*/
function () {
  function Unibit(options) {
    _classCallCheck(this, Unibit);

    this.loader = new _unibitLoader.default({
      inputDir: _lodash.default.get(options, 'inputDir')
    });
    this.site = this.loader.loadSite();
    this.prettierOptions = _lodash.default.get(options, 'prettier');
    this.outputDir = _lodash.default.get(options, 'outputDir', 'output');
    console.log("Unibit: generating site into ".concat(_path.default.resolve(this.outputDir)));
    this.config = _lodash.default.merge({}, this.site.config.data, _lodash.default.get(options, 'config', null));
    this.pages = _lodash.default.cloneDeep(this.site.pages);
    this.renderingPage = null;
    this.pageRenderQueue = [];
    this.loadNunjucksEnv();
  }

  _createClass(Unibit, [{
    key: "fail",
    value: function fail(message) {
      throw new Error("[".concat(this.constructor.name, "] ").concat(message));
    }
  }, {
    key: "assert",
    value: function assert(value, message) {
      if (!value) {
        this.fail(message);
      }
    }
  }, {
    key: "generate",
    value: function generate() {
      this.copyStaticFiles();
      this.compileSass();
      return this.generatePages();
    }
  }, {
    key: "copyStaticFiles",
    value: function copyStaticFiles() {
      var src = _path.default.resolve(this.site.absPath, this.site.staticDir);

      var dest = _path.default.resolve(this.outputDir);

      _fsExtra.default.copySync(src, dest);
    }
  }, {
    key: "compileSass",
    value: function compileSass() {
      var sassOptions = _lodash.default.get(this.config, 'sass', null);

      if (sassOptions) {
        var inputFile = _lodash.default.get(sassOptions, 'input_file', null);

        var outputFile = _lodash.default.get(sassOptions, 'output_file', null);

        this.assert(inputFile, "if sass.input_file must be specified");
        this.assert(inputFile, "if sass.output_file must be specified");
        inputFile = _path.default.resolve(this.site.absPath, inputFile);
        outputFile = _path.default.resolve(this.outputDir, outputFile);
        var inputData = null;
        var includePaths = [_path.default.dirname(inputFile)];

        var ext = _path.default.extname(inputFile);

        if (ext === '.njk') {
          console.log('Unibit: converting scss file with Nunjucks: ' + inputFile);
          inputData = _fs.default.readFileSync(inputFile, 'utf8');
          inputData = this.env.renderString(inputData, {
            site: {
              params: this.config.params
            }
          });
          inputFile = null;
        }

        var res = _nodeSass.default.renderSync({
          file: inputFile,
          data: inputData,
          includePaths: includePaths,
          indentWidth: _lodash.default.get(sassOptions, 'indentWidth', 4),
          outputStyle: _lodash.default.get(sassOptions, 'outputStyle', 'nested'),
          precision: _lodash.default.get(sassOptions, 'precision', 10)
        });

        _fsExtra.default.outputFileSync(outputFile, res.css);
      }
    }
  }, {
    key: "generatePages",
    value: function generatePages() {
      var _this = this;

      this.pages.forEach(function (page) {
        page.content = _this.markdownify(page.markdown);
      });
      var pages = this.pages.filter(function (page) {
        return _lodash.default.get(_this.config.output, page.relDir, true);
      });
      console.log('Unibit: generating ' + pages.length + ' pages...');
      return _utils.default.forEachPromise(pages, function (page) {
        var context = _this.createPageContext(page);

        return _this.renderAndSavePage(context, page.url).then(function () {
          var pageRenderQueue = _lodash.default.remove(_this.pageRenderQueue);

          return _utils.default.forEachPromise(pageRenderQueue, function (renderItem) {
            return _this.renderAndSavePage(renderItem.context, renderItem.outputUrl);
          });
        });
      });
    }
  }, {
    key: "createPageContext",
    value: function createPageContext(page) {
      // console.log('Unibit: generating page for ' + page.relPath);
      var config = this.config;
      var env = this.env;
      var context = {
        site: {
          title: config.title,
          baseurl: config.baseurl,
          pages: this.pages,
          root: this.site.pageTree,
          data: this.site.data,
          menus: this.site.menus,
          params: config.params
        },
        templates: {
          title: null,
          body_class: null
        },
        page: page
      };

      if (!_lodash.default.isEmpty(_lodash.default.get(config, 'templates.title'))) {
        context.templates.title = env.renderString(config.templates.title, context);
      }

      if (!_lodash.default.isEmpty(_lodash.default.get(config, 'templates.body_class'))) {
        context.templates.body_class = env.renderString(config.templates.body_class, context);
      }

      context.paginate = this.paginate.bind(this, context);
      context.link = this.link.bind(this);
      context.classNames = this.classNames.bind(this); // console.log("context:\n" + JSON.stringify(context, null, 4));

      return context;
    }
  }, {
    key: "addPageToRenderQueue",
    value: function addPageToRenderQueue(context, outputUrl) {
      this.pageRenderQueue.push({
        context: context,
        outputUrl: outputUrl
      });
    }
  }, {
    key: "renderAndSavePage",
    value: function renderAndSavePage(context, outputUrl) {
      var _this2 = this;

      this.assert(this.renderingPage === null, "Unibit: tying to generate two pages in parallel");
      this.renderingPage = {
        context: context,
        outputUrl: outputUrl
      };
      return this.renderPage(context).then(function (res) {
        _this2.renderingPage = null;

        _this2.savePage(res, outputUrl);
      });
    }
  }, {
    key: "renderPage",
    value: function renderPage(context) {
      var _this3 = this;

      var templateFile = _lodash.default.get(context.page, 'template', 'body') + '.html';
      return new Promise(function (resolve, reject) {
        _this3.env.render(templateFile, context, function (err, res) {
          if (err) {
            console.error("err:", err);
            reject(err);
          } else {
            //console.log("result:\n" + res);
            resolve(res);
          }
        });
      });
    }
  }, {
    key: "savePage",
    value: function savePage(pageResult, outputUrl) {
      // let res = prettier.format(pageResult, _.merge({
      //     printWidth: 500,
      //     htmlWhitespaceSensitivity: 'css',
      //     parser: 'html',
      //     endOfLine: 'lf'
      // }, this.prettierOptions)) + '\n';
      var outputFile = _path.default.resolve(this.outputDir, outputUrl);

      _fsExtra.default.outputFileSync(outputFile, pageResult);
    }
  }, {
    key: "loadNunjucksEnv",
    value: function loadNunjucksEnv() {
      var fileSystemLoader = new _nunjucks.default.FileSystemLoader([this.loader.templatesDir, this.loader.componentsDir]);
      this.env = new _nunjucks.default.Environment([fileSystemLoader, new _unibitNunjucksLoader.default()]);
      this.env.addFilter('relative_url', this.relativeUrl.bind(this));
      this.env.addFilter('date_format', this.dateFormat);
      this.env.addFilter('slice_array', this.sliceArray);
      this.env.addFilter('sort_array', this.sortArray);
      this.env.addFilter('split', this.split);
      this.env.addFilter('markdownify', this.markdownify.bind(this));
      this.env.addFilter('append', this.append);
      this.env.addFilter('starts_with', this.startsWith);
      this.env.addFilter('ends_with', this.endsWith);
      this.env.addFilter('where', this.where);
      this.env.addFilter('link', this.link.bind(this));
      this.env.addExtension('LinkExtension', new LinkExtension(this));
    }
  }, {
    key: "paginate",
    value: function paginate(context, items, itemsPerPage) {
      var _this4 = this;

      context = _lodash.default.merge({}, context);
      var pagesCount = Math.max(1, Math.ceil(items.length / itemsPerPage));
      var pages = [];

      for (var i = 0; i < pagesCount; i++) {
        var pageNumber = i + 1;
        var url = void 0;

        if (i === 0) {
          url = context.page.url;
        } else {
          url = _path.default.join(context.page.relDir, 'page' + pageNumber, 'index.html');
        }

        var startIdx = i * itemsPerPage;
        var endIdx = Math.min(startIdx + itemsPerPage, items.length);
        var pageItems = items.slice(startIdx, endIdx);
        var page = {
          pageNumber: pageNumber,
          items: pageItems,
          itemsCount: pageItems.length,
          itemsPerPage: itemsPerPage,
          allItems: items,
          allItemsCount: items.length,
          pages: pages,
          pagesCount: pagesCount,
          url: url
        };
        pages.push(page);
      }

      pages.forEach(function (page, index) {
        var hasPrev = index > 0;
        var hasNext = index < pagesCount - 1;
        Object.assign(page, {
          hasPrev: hasPrev,
          prev: hasPrev ? pages[index - 1] : null,
          hasNext: hasNext,
          next: hasNext ? pages[index + 1] : null,
          first: pages[0],
          last: pages[pagesCount - 1]
        });
      });

      _lodash.default.tail(pages).forEach(function (page) {
        var outputUrl = page.url; // override the original paginate function to return current pagination page

        var pageContext = Object.assign({}, context, {
          paginate: function paginate() {
            return page;
          }
        });

        _this4.addPageToRenderQueue(pageContext, outputUrl);
      });

      return pages[0];
    }
  }, {
    key: "sliceArray",
    value: function sliceArray(arr, begin, end) {
      return arr.slice(begin, end);
    }
  }, {
    key: "sortArray",
    value: function sortArray(arr, keyPath) {
      var order = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'asc';
      return _lodash.default.orderBy(arr, keyPath, order);
    }
  }, {
    key: "split",
    value: function split(str, separator) {
      return _lodash.default.split(str, separator);
    }
  }, {
    key: "markdownify",
    value: function markdownify(str) {
      if (_lodash.default.isString(str)) {
        return this.env.filters.safe((0, _marked.default)(str));
      } else {
        return str;
      }
    }
  }, {
    key: "append",
    value: function append(str, appendStr) {
      return str + appendStr;
    }
  }, {
    key: "startsWith",
    value: function startsWith(str, prefix) {
      return _lodash.default.startsWith(str, prefix);
    }
  }, {
    key: "endsWith",
    value: function endsWith(str, prefix) {
      return _lodash.default.endsWith(str, prefix);
    }
  }, {
    key: "relativeUrl",
    value: function relativeUrl(url) {
      if (_lodash.default.startsWith(url, '#') || _lodash.default.startsWith(url, 'http')) {
        return url;
      }

      var urlsRelativeToBase = _lodash.default.get(this.config, 'urls_relative_to_base', true);

      if (!urlsRelativeToBase && !_lodash.default.startsWith(url, '/')) {
        var pageDir = _path.default.parse(this.renderingPage.outputUrl).dir;

        this.assert(!_lodash.default.startsWith(pageDir, '/'), "error in relativeUrl, page dir can not be absolute");
        return _path.default.relative(pageDir, url);
      } else {
        var baseUrl = _lodash.default.get(this.config, 'baseurl', '');

        return _path.default.join(baseUrl, '/', url);
      }
    }
  }, {
    key: "dateFormat",
    value: function dateFormat(date, format, type) {
      type = _lodash.default.defaultTo(type, 'strftime');
      var res;

      if (type === 'strftime') {
        res = (0, _strftime.default)(format, date);
      } else if (type === 'moment') {
        res = (0, _moment.default)(date).format(format);
      } else {
        res = date.toString();
      }

      return res;
    }
  }, {
    key: "where",
    value: function where(array, key, operator, match) {
      var predicate;
      var operatorMap = {
        '==': _lodash.default.eq,
        '!=': function _(value, otherValue) {
          return value !== otherValue;
        },
        '>': _lodash.default.gt,
        '>=': _lodash.default.ge,
        '<': _lodash.default.lt,
        '<=': _lodash.default.le
      };

      if (!operator) {
        predicate = function predicate(element) {
          return _lodash.default.has(element, key);
        };
      } else {
        if (!match) {
          match = operator;
          operator = '==';
        }

        predicate = function predicate(element) {
          var value = _lodash.default.get(element, key);

          return operatorMap[operator](value, match);
        };
      }

      return _lodash.default.filter(array, predicate);
    }
  }, {
    key: "link",
    value: function link(_link) {
      if (_lodash.default.startsWith(_link, '#')) {
        return _link;
      }

      var index = _link.indexOf('#');

      var hash = '';

      if (index !== -1) {
        hash = _link.substring(index);
        _link = _link.substring(0, index);
      }

      var page = _lodash.default.find(this.pages, function (page) {
        if (page.relPath === _link) {
          return true;
        }
      });

      this.assert(page, "could not find page for link: ".concat(_link));
      return page.url + hash;
    }
  }, {
    key: "classNames",
    value: function classNames() {
      var classNames = [];

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _lodash.default.forEach(args, function (arg) {
        if (_lodash.default.isString(arg)) {
          classNames.push(arg);
        } else {
          _lodash.default.forEach(arg, function (value, key) {
            if (value) {
              classNames.push(key);
            }
          });
        }
      });

      if (_lodash.default.isEmpty(classNames)) {
        return '';
      } else {
        return this.env.filters.safe("class=\"".concat(classNames.join(' '), "\""));
      }
    }
  }]);

  return Unibit;
}();

exports.default = Unibit;

var LinkExtension =
/*#__PURE__*/
function () {
  function LinkExtension(unibit) {
    _classCallCheck(this, LinkExtension);

    this.tags = ['link'];
    this.unibit = unibit;
  }

  _createClass(LinkExtension, [{
    key: "parse",
    value: function parse(parser, nodes, lexer) {
      // same implementation as nunjucks.Parser.parseExtends()
      var tagName = 'link';
      var tag = parser.peekToken();

      if (!parser.skipSymbol(tagName)) {
        parser.fail('parseTemplateRef: expected ' + tagName);
      }

      var expression = parser.parseExpression();
      var args = new nodes.NodeList(tag.lineno, tag.colno, [expression]);
      parser.advanceAfterBlockEnd(tag.value);
      return new nodes.CallExtension(this, 'generateLink', args);
    }
  }, {
    key: "generateLink",
    value: function generateLink(context, link) {
      var result = this.unibit.link(link);
      return new _nunjucks.default.runtime.SafeString(result);
    }
  }]);

  return LinkExtension;
}();
//# sourceMappingURL=unibit.js.map

/***/ }),

/***/ "./dist/utils.js":
/*!***********************!*\
  !*** ./dist/utils.js ***!
  \***********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _path = _interopRequireDefault(__webpack_require__(/*! path */ "path"));

var _fs = _interopRequireDefault(__webpack_require__(/*! fs */ "fs"));

var _fsExtra = _interopRequireDefault(__webpack_require__(/*! fs-extra */ "fs-extra"));

var _lodash = _interopRequireDefault(__webpack_require__(/*! lodash */ "lodash"));

var _mime = _interopRequireDefault(__webpack_require__(/*! mime */ "mime"));

var _jsYaml = _interopRequireDefault(__webpack_require__(/*! js-yaml */ "js-yaml"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

module.exports = {
  forEachPromise: forEachPromise,
  promiseAllMap: promiseAllMap,
  copyFilesRecursively: copyFilesRecursively,
  copy: copy,
  copyDefault: copyDefault,
  append: append,
  concat: concat,
  indent: indent,
  pascalCase: pascalCase,
  getFileMimePath: getFileMimePath,
  readDirRecSync: readDirRecSync,
  fieldPathToString: fieldPathToString,
  hrtimeAndPrint: hrtimeAndPrint,
  printHRTime: printHRTime,
  forEachDeep: forEachDeep,
  mapDeep: mapDeep,
  parseFileSync: parseFileSync,
  parseDataByFilePath: parseDataByFilePath,
  outputDataSync: outputDataSync,
  stringifyDataByFilePath: stringifyDataByFilePath,
  deepFreeze: deepFreeze,
  joinPathAndGlob: joinPathAndGlob
};

var INDENT = _lodash.default.repeat(' ', 4);
/**
 * Iterates over array items and invokes callback function for each of them.
 * The callback must return a promise and is called with three parameters: array item,
 * item index, array itself. Callbacks are invoked serially, such that callback for the
 * following item will not be called until the promise returned from the previous callback
 * is not fulfilled.
 *
 * @param {array} array
 * @param {function} callback
 * @param {object} [thisArg]
 * @return {Promise<any>}
 */


function forEachPromise(array, callback, thisArg) {
  return new Promise(function (resolve, reject) {
    var results = [];

    function next(index) {
      if (index < array.length) {
        callback.call(thisArg, array[index], index, array).then(function (result) {
          results[index] = result;
          next(index + 1);
        }).catch(function (error) {
          reject(error);
        });
      } else {
        resolve(results);
      }
    }

    next(0);
  });
}

function promiseAllMap(array, limit, interval, callback, thisArg) {
  return new Promise(function (resolve, reject) {
    var arrayCopy = array.slice();
    var results = [];
    var index = 0;
    var runCount = 0;
    var doneCount = 0;
    var lastRunTime = null;
    var timeout = null;
    limit = limit || null;
    interval = interval || null;

    function run() {
      var idx = index;

      if (timeout) {
        clearTimeout(timeout);
        timeout = null;
      }

      index += 1;
      runCount += 1;
      lastRunTime = process.hrtime();
      Promise.resolve(callback.call(thisArg, arrayCopy[idx], idx, arrayCopy)).then(function (result) {
        runCount -= 1;
        doneCount += 1;
        results.push(result);
        next();
      }).catch(function (error) {
        reject(error);
      });
      next();
    }

    if (interval) {
      var origRun = run;

      run = function run() {
        if (!lastRunTime) {
          origRun();
        } else if (!timeout) {
          var diff = process.hrtime(lastRunTime);
          var diffMs = diff[0] * 1000 + diff[1] / 1000000;

          if (diffMs >= interval) {
            origRun();
          } else {
            timeout = setTimeout(origRun, interval - diffMs);
          }
        }
      };
    }

    if (limit) {
      var _origRun = run;

      run = function run() {
        if (runCount < limit) {
          _origRun();
        }
      };
    }

    function next() {
      if (index < arrayCopy.length) {
        run();
      } else if (doneCount === arrayCopy.length) {
        resolve(results);
      }
    }

    next();
  });
}
/**
 * Recursively copies files from source to target directories.
 * The optional "options" argument is an object with an optional "processNunjucksFile"
 * and "filePathMap" fields.
 * 
 * If "processNunjucksFile" function is passed, it will be invoked for every file with ".njk"
 * extension with a filepath relative to the sourceDir as its single argument.
 * This function should return the result of processing Nunjucks template.
 *
 * Files named _gitignore will be copied as .gitignore
 *
 * @param {string} sourceDir
 * @param {string} targetDir
 * @param {object} [options]
 * @param {function} options.processNunjucksFile
 * @param {object} options.filePathMap
 */


function copyFilesRecursively(sourceDir, targetDir, options, _internalOptions) {
  if (!_internalOptions) {
    _internalOptions = {
      origSourceDir: sourceDir,
      origTargetDir: targetDir
    };
  }

  _fs.default.readdirSync(sourceDir).forEach(function (fileName) {
    var sourceFilePath = _path.default.join(sourceDir, fileName);

    var targetFilePath = _path.default.join(targetDir, fileName);

    var fileStat = _fs.default.statSync(sourceFilePath);

    if (fileStat.isDirectory()) {
      copyFilesRecursively(sourceFilePath, targetFilePath, options, _internalOptions);
    } else if (fileStat.isFile()) {
      var outputPathObject = _path.default.parse(targetFilePath);

      var data = null;

      if (outputPathObject.ext === '.njk') {
        if (!_lodash.default.has(options, 'processNunjucksFile') || !_lodash.default.isFunction(options.processNunjucksFile)) {
          throw new Error("utils.copyFilesRecursively(): file (".concat(sourceFilePath, ") has '.njk' extension but processNunjucksFile function was not passed"));
        }

        var relativeSourceFilePath = _path.default.relative(_internalOptions.origSourceDir, sourceFilePath);

        data = options.processNunjucksFile(relativeSourceFilePath);
        targetFilePath = _path.default.resolve(outputPathObject.dir, outputPathObject.name);
      }

      var relativeTargetFilePath = _path.default.relative(_internalOptions.origTargetDir, targetFilePath);

      if (_lodash.default.has(options, ['filePathMap', relativeTargetFilePath])) {
        targetFilePath = _path.default.join(_internalOptions.origTargetDir, options.filePathMap[relativeTargetFilePath]);
      }

      if (fileName === '_gitignore') {
        targetFilePath = _path.default.resolve(outputPathObject.dir, '.gitignore');
      }

      if (!data) {
        _fsExtra.default.copySync(sourceFilePath, targetFilePath);
      } else {
        _fsExtra.default.outputFileSync(targetFilePath, data, {
          mode: fileStat.mode
        });
      }
    } else {
      throw new Error("utils.copyFilesRecursively(): file type is not supported: ".concat(sourceFilePath));
    }
  });
}
/**
 * Copies the value at a sourcePath of the sourceObject to a targetPath of the targetObject.
 *
 * @param {Object} sourceObject
 * @param {String} sourcePath
 * @param {Object} targetObject
 * @param {String} targetPath
 * @param {Function} [transform]
 */


function copy(sourceObject, sourcePath, targetObject, targetPath, transform) {
  if (_lodash.default.has(sourceObject, sourcePath)) {
    var value = _lodash.default.get(sourceObject, sourcePath);

    if (transform) {
      value = transform(value);
    }

    _lodash.default.set(targetObject, targetPath, value);
  }
}

function copyDefault(sourceObject, sourcePath, targetObject, targetPath, transform) {
  if (!_lodash.default.has(targetObject, targetPath)) {
    copy(sourceObject, sourcePath, targetObject, targetPath, transform);
  }
}

function append(object, path, value) {
  if (!_lodash.default.has(object, path)) {
    _lodash.default.set(object, path, []);
  }

  _lodash.default.get(object, path).push(value);
}

function concat(object, path, value) {
  if (!_lodash.default.has(object, path)) {
    _lodash.default.set(object, path, []);
  }

  _lodash.default.set(object, path, _lodash.default.get(object, path).concat(value));
}

function indent(str, indent) {
  var indentFirst = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  if (_lodash.default.isNumber(indent)) {
    indent = _lodash.default.repeat(INDENT, indent);
  }

  return (indentFirst ? indent : '') + str.split('\n').join("\n".concat(indent));
}

function pascalCase(str) {
  return _lodash.default.upperFirst(_lodash.default.camelCase(str));
}

function getFileMimePath(path) {
  return _mime.default.getType(path);
}

function readDirRecSync(dir) {
  var list = [];

  var files = _fs.default.readdirSync(dir);

  _lodash.default.forEach(files, function (file) {
    var filePath = _path.default.join(dir, file);

    var stats = _fs.default.statSync(filePath);

    if (stats.isDirectory()) {
      list = list.concat(readDirRecSync(filePath));
    } else if (stats.isFile()) {
      list.push(filePath);
    }
  });

  return list;
}

function fieldPathToString(fieldPath) {
  return _lodash.default.reduce(fieldPath, function (accumulator, fieldName, index) {
    if (_lodash.default.isString(fieldName) && /\W/.test(fieldName)) {
      // field name is a string with non alphanumeric character
      accumulator += "['".concat(fieldName, "']");
    } else if (_lodash.default.isNumber(fieldName)) {
      accumulator += "[".concat(fieldName, "]");
    } else {
      if (index > 0) {
        accumulator += '.';
      }

      accumulator += fieldName;
    }

    return accumulator;
  }, '');
}

function hrtimeAndPrint(time) {
  var res = process.hrtime(time);
  return printHRTime(res);
}

function printHRTime(time) {
  var precision = 3;

  if (time[0] > 0) {
    return _lodash.default.round(time[0] + time[1] / 1e9, precision) + 'sec';
  } else if (time[1] >= 1e6) {
    return _lodash.default.round(time[1] / 1e6, precision) + 'ms';
  } else if (time[1] >= 1e3) {
    return _lodash.default.round(time[1] / 1e3, precision) + 'µs';
  } else if (time[1] >= 1e3) {
    return _lodash.default.round(time[1], precision) + 'ns';
  }
}
/**
 * Recursively iterates over elements of a collection and invokes iteratee for each element.
 *
 * @param {*} value The value to iterate
 * @param {Function} iteratee The iteratee function
 * @param {string|number} key The key of the `value` if the `object` is an Object, or the index of the `value` if the `object` is an Array
 * @param {Object} object The parent object of `value`.
 */


function forEachDeep(value, iteratee, key, object) {
  iteratee(value, key, object);

  if (_lodash.default.isPlainObject(value)) {
    _lodash.default.forEach(value, function (v, k) {
      forEachDeep(v, iteratee, k, value);
    });
  } else if (_lodash.default.isArray(value)) {
    _lodash.default.forEach(value, function (v, k) {
      forEachDeep(v, iteratee, k, value);
    });
  }
}

function mapDeep(value, iteratee, keyPath, objectStack) {
  var mappedValue = iteratee(value, keyPath, objectStack);
  keyPath = keyPath || [];
  objectStack = objectStack || [];

  if (_lodash.default.has(mappedValue, 'value')) {
    value = _lodash.default.get(mappedValue, 'value');
  } else if (_lodash.default.isPlainObject(value)) {
    value = _lodash.default.reduce(value, function (obj, v, k) {
      var res = mapDeep(v, iteratee, _lodash.default.concat(keyPath, k), _lodash.default.concat(objectStack, value));
      obj[_lodash.default.get(res, 'key', k)] = _lodash.default.get(res, 'value', v);
      return obj;
    }, {});
  } else if (_lodash.default.isArray(value)) {
    value = _lodash.default.map(value, function (v, k) {
      var res = mapDeep(v, iteratee, _lodash.default.concat(keyPath, k), _lodash.default.concat(objectStack, value));
      return _lodash.default.get(res, 'value', v);
    });
  }

  if (!_lodash.default.isEmpty(keyPath)) {
    return {
      value: value,
      key: _lodash.default.get(mappedValue, 'key', _lodash.default.last(keyPath))
    };
  }

  return value;
}

function parseFileSync(filePath) {
  var data = _fs.default.readFileSync(filePath, 'utf8');

  return parseDataByFilePath(data, filePath);
}

function parseDataByFilePath(string, filePath) {
  var extension = _path.default.extname(filePath).substring(1);

  var data;

  switch (extension) {
    case 'yml':
    case 'yaml':
      data = _jsYaml.default.safeLoad(string, {
        schema: _jsYaml.default.JSON_SCHEMA
      });
      break;

    case 'json':
      data = JSON.parse(string);
      break;

    default:
      throw new Error("parseDataByFilePath error, extension '".concat(extension, "' of file ").concat(filePath, " is not supported"));
  }

  return data;
}

function outputDataSync(filePath, data) {
  var res = stringifyDataByFilePath(data, filePath);

  _fsExtra.default.outputFileSync(filePath, res);
}

function stringifyDataByFilePath(data, filePath) {
  var extension = _path.default.extname(filePath).substring(1);

  var result;

  switch (extension) {
    case 'yml':
    case 'yaml':
      result = _jsYaml.default.safeDump(data);
      break;

    case 'json':
      result = JSON.stringify(data, null, 4);
      break;

    case 'md':
      result = '---\n' + _jsYaml.default.safeDump(data.frontmatter) + '---\n' + data.markdown;
      break;

    default:
      throw new Error("stringifyDataByFilePath error, extension '".concat(extension, "' of file ").concat(filePath, " is not supported"));
  }

  return result;
}

function deepFreeze(obj) {
  var _this = this;

  Object.freeze(obj);
  Object.getOwnPropertyNames(obj).forEach(function (prop) {
    if (obj.hasOwnProperty(prop) && obj[prop] !== null && (_typeof(obj[prop]) === "object" || typeof obj[prop] === "function") && !Object.isFrozen(obj[prop])) {
      _this.deepFreeze(obj[prop]);
    }
  });
  return obj;
}

function joinPathAndGlob(pathStr, glob) {
  var globParts = _lodash.default.chain(glob).trim('{}').split(',').compact().map(function (globPart) {
    return _path.default.join(pathStr, globPart);
  }).value();

  return globParts.length > 1 ? "{".concat(globParts.join(','), "}") : _lodash.default.head(globParts);
}
//# sourceMappingURL=utils.js.map

/***/ }),

/***/ "fs":
/*!*********************!*\
  !*** external "fs" ***!
  \*********************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("fs");

/***/ }),

/***/ "fs-extra":
/*!***************************!*\
  !*** external "fs-extra" ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("fs-extra");

/***/ }),

/***/ "js-yaml":
/*!**************************!*\
  !*** external "js-yaml" ***!
  \**************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("js-yaml");

/***/ }),

/***/ "lodash":
/*!*************************!*\
  !*** external "lodash" ***!
  \*************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("lodash");

/***/ }),

/***/ "marked":
/*!*************************!*\
  !*** external "marked" ***!
  \*************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("marked");

/***/ }),

/***/ "mime":
/*!***********************!*\
  !*** external "mime" ***!
  \***********************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("mime");

/***/ }),

/***/ "moment":
/*!*************************!*\
  !*** external "moment" ***!
  \*************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("moment");

/***/ }),

/***/ "node-sass":
/*!****************************!*\
  !*** external "node-sass" ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("node-sass");

/***/ }),

/***/ "nunjucks":
/*!***************************!*\
  !*** external "nunjucks" ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("nunjucks");

/***/ }),

/***/ "path":
/*!***********************!*\
  !*** external "path" ***!
  \***********************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("path");

/***/ }),

/***/ "prettier":
/*!***************************!*\
  !*** external "prettier" ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("prettier");

/***/ }),

/***/ "strftime":
/*!***************************!*\
  !*** external "strftime" ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("strftime");

/***/ }),

/***/ "yargs":
/*!************************!*\
  !*** external "yargs" ***!
  \************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("yargs");

/***/ })

/******/ });